﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Vez
{
    public partial class Form1 : Form
    {
        Plan zobrazPlan;

        public Form1()
        {
            InitializeComponent();
        }
        
        private void button3_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox2.Text = openFileDialog1.FileName;
            }
        }

        //zpracovat plan
        private void button4_Click(object sender, EventArgs e)
        {
            StreamReader reader;

            try
            {
                reader = new StreamReader(textBox2.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
                return;
            }

            string[] data = RemoveSpaces(reader.ReadLine()).Trim().Split(' ');

            zobrazPlan = new Plan(Convert.ToInt32(data[0]), Convert.ToInt32(data[1]),
                data[2].ToUpper()[0] == 'P', data[2].Length > 1);

            Dictionary<Kostka, int> kostky = new Dictionary<Kostka, int>();

            string line; int vrstva;

            while ((line = reader.ReadLine()) != null)
            {
                if (line.Length < 1)
                    continue;
                data = RemoveSpaces(line).Trim().Split(' ');

                vrstva = Convert.ToInt32(data[0]) - 1;

                if (zobrazPlan.vrstvy.Count < vrstva + 1)
                    zobrazPlan.vrstvy.Add(new List<KostkaPlanu>());

                string[] rozmer = data[4].ToLower().Split('x');

                Kostka kostka = new Kostka(Convert.ToInt32(rozmer[0]), Convert.ToInt32(rozmer[1]),
                    data[3].Trim().ToUpper()[0]);


                foreach (var item in kostky)
                {
                    if (kostka.Stejna(item.Key))
                    {
                        kostky[item.Key]++;
                        goto pricteno;
                    }
                }
                kostky.Add(kostka, 1);
            pricteno:

                zobrazPlan.vrstvy[vrstva].Add(new KostkaPlanu(Convert.ToInt32(data[1]), Convert.ToInt32(data[2]),
                    kostka.barva, Convert.ToInt32(rozmer[0]), Convert.ToInt32(rozmer[1])));
            }

            listBox1.Items.Clear();
            foreach (var kostka in kostky)
            {
                listBox1.Items.Add(kostka.Key.barva.ToString() + " " + kostka.Key.x.ToString() + "x" + kostka.Key.y.ToString()
                    + ": " + kostka.Value.ToString() + " krát\n");
            }
            reader.Close();

            numericUpDown1.Maximum = zobrazPlan.vrstvy.Count;
            panel1.Refresh();
        }

        //smazat zbytecne mezery
        public string RemoveSpaces(string line)
        {
            while (line.Contains("  "))
            {
                line = line.Replace("  ", " ");
            }
            return line;
        }

        //kreslení
        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            if (zobrazPlan == null)
                return;

            Graphics g = e.Graphics;

            if (radioButton1.Checked)   //vrstvy
            {
                int vrstva = (int)numericUpDown1.Value - 1;
                foreach (var kostka in zobrazPlan.vrstvy[vrstva])
                {
                    g.FillRectangle(Stetec(kostka.barva), kostka.x * 20, kostka.y * 20, kostka.rx * 20, kostka.ry * 20);
                    g.DrawRectangle(Pens.Black, kostka.x * 20, kostka.y * 20, kostka.rx * 20, kostka.ry * 20);
                }
            }
            else if (radioButton2.Checked)  //zepredu
            {
                for (int i = 0; i < zobrazPlan.vrstvy.Count; i++)
                {
                    List<KostkaPlanu> kostky = zobrazPlan.vrstvy[i].OrderBy(x => (x.x + x.rx)).ToList().OrderByDescending(x => (x.y + x.ry)).ToList();

                    for (int j = 0; j < kostky.Count; j++)
                    {
                        if (checkBox1.Checked)
                        {
                            Point[] body = { new Point(kostky[j].x * 20 + kostky[j].y * 10, (21 - i) * 20 - kostky[j].y * 10),
                                          new Point(kostky[j].x * 20 + 20 * kostky[j].rx + kostky[j].y * 10, (21 - i) * 20 - kostky[j].y * 10),
                                          new Point(kostky[j].x * 20 + 20 * kostky[j].rx + 10 * kostky[j].ry + kostky[j].y * 10, (21 - i) * 20 - 10*kostky[j].ry - kostky[j].y * 10),
                                          new Point(kostky[j].x * 20 + 10 * kostky[j].ry + kostky[j].y * 10, (21 - i) * 20 - 10*kostky[j].ry - kostky[j].y * 10) };
                            g.FillPolygon(Stetec(kostky[j].barva), body);
                            g.DrawPolygon(Pens.Black, body);

                            body[0].X = kostky[j].x * 20 + kostky[j].rx * 20 + kostky[j].y * 10; body[0].Y = (21 - i) * 20 - kostky[j].y * 10;
                            body[1].X = kostky[j].x * 20 + kostky[j].rx * 20 + kostky[j].y * 10; body[1].Y = (21 - i) * 20 - kostky[j].y * 10 + 20;
                            body[2].X = kostky[j].x * 20 + kostky[j].rx * 20 + kostky[j].y * 10 + 10 * kostky[j].ry; body[2].Y = (21 - i) * 20 - kostky[j].y * 10 + 20 - 10 * kostky[j].ry;
                            body[3].X = kostky[j].x * 20 + kostky[j].rx * 20 + kostky[j].y * 10 + 10 * kostky[j].ry; body[3].Y = (21 - i) * 20 - kostky[j].y * 10 - 10 * kostky[j].ry;
                            g.FillPolygon(Stetec(kostky[j].barva), body);
                            g.DrawPolygon(Pens.Black, body);

                            g.FillRectangle(Stetec(kostky[j].barva), kostky[j].x * 20 + kostky[j].y * 10,
                            (21 - i) * 20 - kostky[j].y * 10, kostky[j].rx * 20, 20);
                            g.DrawRectangle(Pens.Black, kostky[j].x * 20 + kostky[j].y * 10,
                                (21 - i) * 20 - kostky[j].y * 10, kostky[j].rx * 20, 20);
                        }
                        else
                        {
                            g.FillRectangle(Stetec(kostky[j].barva), kostky[j].x * 20,
                                (21 - i) * 20, kostky[j].rx * 20, 20);
                            g.DrawRectangle(Pens.Black, kostky[j].x * 20,
                                (21 - i) * 20, kostky[j].rx * 20, 20);
                        }
                    }
                }
            }
            else if (radioButton3.Checked)  //zleva
            {
                for (int i = 0; i < zobrazPlan.vrstvy.Count; i++)
                {
                    List<KostkaPlanu> kostky = zobrazPlan.vrstvy[i].OrderByDescending(x => x.x).ToList();

                    for (int j = 0; j < kostky.Count; j++)
                    {
                        g.FillRectangle(Stetec(kostky[j].barva), kostky[j].y * 20, (21 - i) * 20, kostky[j].ry * 20, 20);
                        g.DrawRectangle(Pens.Black, kostky[j].y * 20, (21 - i) * 20, kostky[j].ry * 20, 20);
                    }
                }
            }
            else if (radioButton4.Checked)  //zprava
            {
                for (int i = 0; i < zobrazPlan.vrstvy.Count; i++)
                {
                    List<KostkaPlanu> kostky = zobrazPlan.vrstvy[i].OrderBy(x => x.x).ToList();

                    for (int j = 0; j < kostky.Count; j++)
                    {
                        g.FillRectangle(Stetec(kostky[j].barva), kostky[j].y * 20, (21 - i) * 20, kostky[j].ry * 20, 20);
                        g.DrawRectangle(Pens.Black, kostky[j].y * 20, (21 - i) * 20, kostky[j].ry * 20, 20);
                    }
                }
            }
            else if (radioButton5.Checked)  //zezadu
            {
                for (int i = 0; i < zobrazPlan.vrstvy.Count; i++)
                {
                    List<KostkaPlanu> kostky = zobrazPlan.vrstvy[i].OrderByDescending(x => (x.x + x.rx)).ToList().OrderBy(x => (x.y + x.ry)).ToList();

                    for (int j = 0; j < kostky.Count; j++)
                    {
                        if (checkBox1.Checked)
                        {
                            Point[] body = { new Point(kostky[j].x * 20 + kostky[j].y * 10, (21 - i) * 20 - kostky[j].y * 10),
                                          new Point(kostky[j].x * 20 + 20 * kostky[j].rx + kostky[j].y * 10, (21 - i) * 20 - kostky[j].y * 10),
                                          new Point(kostky[j].x * 20 + 20 * kostky[j].rx + 10 * kostky[j].ry + kostky[j].y * 10, (21 - i) * 20 - 10*kostky[j].ry - kostky[j].y * 10),
                                          new Point(kostky[j].x * 20 + 10 * kostky[j].ry + kostky[j].y * 10, (21 - i) * 20 - 10*kostky[j].ry - kostky[j].y * 10) };
                            g.FillPolygon(Stetec(kostky[j].barva), body);
                            g.DrawPolygon(Pens.Black, body);

                            body[0].X = kostky[j].x * 20 + kostky[j].rx * 20 + kostky[j].y * 10; body[0].Y = (21 - i) * 20 - kostky[j].y * 10;
                            body[1].X = kostky[j].x * 20 + kostky[j].rx * 20 + kostky[j].y * 10; body[1].Y = (21 - i) * 20 - kostky[j].y * 10 + 20;
                            body[2].X = kostky[j].x * 20 + kostky[j].rx * 20 + kostky[j].y * 10 + 10 * kostky[j].ry; body[2].Y = (21 - i) * 20 - kostky[j].y * 10 + 20 - 10 * kostky[j].ry;
                            body[3].X = kostky[j].x * 20 + kostky[j].rx * 20 + kostky[j].y * 10 + 10 * kostky[j].ry; body[3].Y = (21 - i) * 20 - kostky[j].y * 10 - 10 * kostky[j].ry;
                            g.FillPolygon(Stetec(kostky[j].barva), body);
                            g.DrawPolygon(Pens.Black, body);

                            g.FillRectangle(Stetec(kostky[j].barva), kostky[j].x * 20 + kostky[j].y * 10,
                            (21 - i) * 20 - kostky[j].y * 10, kostky[j].rx * 20, 20);
                            g.DrawRectangle(Pens.Black, kostky[j].x * 20 + kostky[j].y * 10,
                                (21 - i) * 20 - kostky[j].y * 10, kostky[j].rx * 20, 20);
                        }
                        else
                        {
                            g.FillRectangle(Stetec(kostky[j].barva), kostky[j].x * 20,
                                (21 - i) * 20, kostky[j].rx * 20, 20);
                            g.DrawRectangle(Pens.Black, kostky[j].x * 20,
                                (21 - i) * 20, kostky[j].rx * 20, 20);
                        }
                    }
                }
            }
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            panel1.Refresh();
        }

        public Brush Stetec(char barva)
        {
            switch (barva)
            {
                case 'A':
                    return Brushes.Azure;
                case 'R':
                    return Brushes.Red;
                case 'G':
                    return Brushes.Green;
                case 'B':
                    return Brushes.Blue;
                case 'Y':
                    return Brushes.Yellow;
                default:
                    return Brushes.White;
            }
        }

        //vytvořit plán
        private void button2_Click(object sender, EventArgs e)
        {
            string[] filePaths = Directory.GetFiles(textBox1.Text, "*.in");
            StreamReader reader;

            filePaths.OrderBy(x => x);

            foreach (var filePath in filePaths)
            {
                try
                {
                    reader = new StreamReader(filePath);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                    continue;
                }

                string[] data = RemoveSpaces(reader.ReadLine()).Trim().Split(' ');

                Plan plan = new Plan(Convert.ToInt32(data[0]), Convert.ToInt32(data[1]),
                    data[2].ToUpper()[0] == 'P', data[2].Length > 1);

                Dictionary<Kostka, int> kostky = new Dictionary<Kostka, int>();

                string line;
                while ((line = reader.ReadLine())!= null)
                {
                    if (line.Length < 1)
                        continue;

                    data = RemoveSpaces(line).Trim().Split(' ');
                    string[] rozmer = data[1].ToLower().Split('x');

                    kostky.Add(new Kostka(Convert.ToInt32(rozmer[0]), Convert.ToInt32(rozmer[1]), data[0].ToUpper()[0]),
                        Convert.ToInt32(data[2]));
                }
                reader.Close();

                StreamWriter writer = new StreamWriter(filePath.Replace(".in", ".16"));
                writer.WriteLine(plan.x.ToString() + " " + plan.y.ToString() + " "
                    + (plan.plna ? "P" : "S") + (plan.barvy ? "B" : ""));

                writer.Close();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog()==DialogResult.OK)
            {
                textBox1.Text = folderBrowserDialog1.SelectedPath;
            }
        }
    }

    public class Plan
    {
        public int x, y;
        public bool plna, barvy;

        public List<List<KostkaPlanu>> vrstvy = new List<List<KostkaPlanu>>();

        public Plan(int x, int y, bool plna, bool barvy)
        {
            this.x = x;
            this.y = y;
            this.plna = plna;
            this.barvy = barvy;
        }
    }

    public class Kostka
    {
        public int x, y;
        public char barva;

        public Kostka(int x, int y, char barva)
        {
            this.x = Math.Min(x, y);
            this.y = Math.Max(x, y);
            this.barva = barva;
        }

        public bool Stejna(Kostka kostka)
        {
            if (this.x == kostka.x && this.y == kostka.y && this.barva == kostka.barva)
                return true;
            else
                return false;
        }

        public int Plocha()
        {
            return x * y;
        }
    }

    public class KostkaPlanu
    {
        public int x, y;    //poloha
        public int rx, ry;  //rozmery
        public char barva;

        public KostkaPlanu(int x, int y, char barva, int rx, int ry)
        {
            this.x = x;
            this.y = y;
            this.rx = rx;
            this.ry = ry;
            this.barva = barva;
        }
    }
}